#include <bits/stdc++.h>

using namespace std;

int main()
{
   ios_base::sync_with_stdio(0);
    cin.tie(0);
   unsigned long long int n,q;
   cin>>n>>q;
   unsigned long long int d[n];
   unsigned long long int p[n];
   unsigned long long int k[q];

   for(unsigned long long int i=0;i<n;i++){
        cin>>d[i]>>p[i];
   }
   for(unsigned long long int i=0;i<q;i++){
        cin>>k[i];
   }
   unsigned long long int ukupno=0,trenutno=0,j=0,l=0;
   for(unsigned long long int i=0;i<n;i++){
        while(d[i]>k[j]){
            cout<<ukupno<<"\n";
            j++;
            l=d[i]-1;
        }
        trenutno+=p[i]-1;
        while(l+trenutno>=d[i+1]-1){
            if(i+1==n){
                break;
            }
            trenutno+=p[i+1];
            i++;
        }
        while(k[j]-1<=l+trenutno){
            if(j==q){
                break;
            }
            ukupno+=(k[j]-1)-l+1;
            trenutno-=((k[j]-1)-l);
            l=k[j]-1;
            cout<<ukupno<<"\n";
            j++;
            ukupno--;
        }
        trenutno++;
        ukupno+=trenutno;
        trenutno=0;
        l=d[i+1]-1;
        while(k[j]<l){
            cout<<ukupno<<"\n";
            j++;
        }
        l=d[i+1]-1;
        if(i==n-1){
            while(j<q){
                cout<<ukupno<<"\n";
                j++;
            }
        }
   }
}